routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::middleware(['auth'])->group(function () {
    Route::get('/home', 'HomeController@index')->name('home');
    Route::resource('department', DepartmentController::class);
    Route::resource('jenis-surat', JenisSuratController::class);
    Route::resource('user', UserController::class);
    Route::resource('nomor-surat', NomorSuratController::class);
});

app/Models/JenisSurat.php
<?php

/**
 * Created by Reliese Model.
 */

namespace App\Models;

use Carbon\Carbon;
use Illuminate\Database\Eloquent\Model;

/**
 * Class JenisSurat
 * 
 * @property int $id
 * @property string $kode_surat
 * @property string $jenis_surat
 * @property Carbon|null $created_at
 * @property Carbon|null $updated_at
 *
 * @package App\Models
 */
class JenisSurat extends Model
{
	protected $table = 'jenis_surats';

	protected $fillable = [
		'kode_surat',
		'jenis_surat'
	];
}

app/Http/Controllers/JenisSuratController.php
<?php

namespace App\Http\Controllers;

use DB;
use App\Models\JenisSurat;
use Illuminate\Http\Request;

class JenisSuratController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $listJenis = JenisSurat::get();

        return view('pages.jenis-surat.index', compact('listJenis'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('pages.jenis-surat.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'kode_surat' => 'required',
            'jenis_surat' => 'required',
        ]);

        DB::beginTransaction();
        try {

            JenisSurat::create([
                'kode_surat' => $request->kode_surat,
                'jenis_surat' => $request->jenis_surat,
            ]);
            
            DB::commit();
            return redirect(route('jenis-surat.index'))->with('info', 'berhasil di proses');
        } catch (\Throwable $th) {
            //throw $th;
            DB::rollback();
            return redirect()->back()->withInput()->withErrors('gagal input data');
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $idJenis = \Crypt::decrypt($id);
        $jenisSurat = JenisSurat::findorfail($idJenis);
        
        return view('pages.jenis-surat.edit', compact('jenisSurat'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'kode_surat' => 'required',
            'jenis_surat' => 'required',
        ]);

        DB::beginTransaction();
        try {

            $idJenis = \Crypt::decrypt($id);
            $jenisSurat = JenisSurat::findorfail($idJenis);

            $jenisSurat->kode_surat = $request->kode_surat;
            $jenisSurat->jenis_surat = $request->jenis_surat;
            $jenisSurat->save();
            
            DB::commit();
            return redirect(route('jenis-surat.index'))->with('info', 'berhasil di update');
        } catch (\Throwable $th) {
            //throw $th;
            DB::rollback();
            return redirect()->back()->withInput()->withErrors('gagal input data');
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $idJenis = \Crypt::decrypt($id);
        $jenisSurat = JenisSurat::findorfail($idJenis);

        $jenisSurat->delete();

        return redirect(route('jenis-surat.index'))->with('info', 'berhasil di delete');
    }
}

resources/views/pages/jenis-surat/create.blade.php
@extends('layouts.app')

@section('title', 'Create Jenis Surat')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            @include('components.alert-info')

            @include('components.alert-error')

            <div class="card">
                <div class="card-header">{{ __('Create Jenis Surat') }}</div>

                <div class="card-body">
                    <form method="POST" action="{{ route('jenis-surat.store') }}">
                        @csrf

                        <div class="form-group row">
                            <label for="kode_surat" class="col-md-4 col-form-label text-md-right">{{ __('Kode Surat') }}</label>

                            <div class="col-md-6">
                                <input id="kode_surat" type="text" class="form-control @error('kode_surat') is-invalid @enderror" name="kode_surat" value="{{ old('kode_surat') }}" required autocomplete="kode_surat" autofocus>

                                @error('kode_surat')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="jenis_surat" class="col-md-4 col-form-label text-md-right">{{ __('Jenis Surat') }}</label>

                            <div class="col-md-6">
                                <input id="jenis_surat" type="text" class="form-control @error('jenis_surat') is-invalid @enderror" name="jenis_surat" value="{{ old('jenis_surat') }}" required autocomplete="jenis_surat" autofocus>

                                @error('jenis_surat')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>


                        <div class="form-group row mb-0">
                            <div class="col-md-6 offset-md-4">
                                <button type="submit" class="btn btn-primary">
                                    {{ __('Save') }}
                                </button>
                                <a href="{{ route('jenis-surat.index') }}">
                                <button type="button" class="btn btn-danger">
                                    {{ __('Cancel') }}
                                </button>
                                </a>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('script')
    
@endsection

resources/views/pages/jenis-surat/edit.blade.php
@extends('layouts.app')

@section('title', 'Edit Jenis Surat')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            @include('components.alert-info')

            @include('components.alert-error')

            <div class="card">
                <div class="card-header">{{ __('Edit Jenis Surat') }}</div>

                <div class="card-body">
                    <form method="POST" action="{{ route('jenis-surat.update', \Crypt::encrypt($jenisSurat->id)) }}">
                        @csrf
                        <input type="hidden" name="_method" value="PUT">

                        <div class="form-group row">
                            <label for="kode_surat" class="col-md-4 col-form-label text-md-right">{{ __('Kode Surat') }}</label>

                            <div class="col-md-6">
                                <input id="kode_surat" type="text" class="form-control @error('kode_surat') is-invalid @enderror" name="kode_surat" value="{{ old('kode_surat', $jenisSurat->kode_surat) }}" required autocomplete="kode_surat" autofocus>

                                @error('kode_surat')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="jenis_surat" class="col-md-4 col-form-label text-md-right">{{ __('Jenis Surat') }}</label>

                            <div class="col-md-6">
                                <input id="jenis_surat" type="text" class="form-control @error('jenis_surat') is-invalid @enderror" name="jenis_surat" value="{{ old('jenis_surat', $jenisSurat->jenis_surat) }}" required autocomplete="jenis_surat" autofocus>

                                @error('jenis_surat')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>


                        <div class="form-group row mb-0">
                            <div class="col-md-6 offset-md-4">
                                <button type="submit" class="btn btn-primary">
                                    {{ __('Update') }}
                                </button>
                                <a href="{{ route('jenis-surat.index') }}">
                                <button type="button" class="btn btn-danger">
                                    {{ __('Cancel') }}
                                </button>
                                </a>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('script')
    
@endsection

resources/views/pages/jenis-surat/index.blade.php
@extends('layouts.app')

@section('title', 'Jenis Surat')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            @include('components.alert-info')

            @include('components.alert-error')

            <div class="card">
                <div class="card-header">{{ __('Jenis Surat') }}</div>

                <div class="card-body">
                    <div class="form-group row mb-4">
                        <div class="col-md-6">
                            <a href="{{ route('jenis-surat.create') }}">
                            <button type="button" class="btn btn-primary">
                                {{ __('Input Data') }}
                            </button>
                            </a>
                        </div>
                    </div>
                    <table id="jenis-surat" class="table table-striped table-bordered" style="width:100%">
                        <thead>
                            <tr>
                                <th>Kode Surat</th>
                                <th>Jenis Surat</th>
                                <th>Aksi</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach ( $listJenis as $item)
                            <tr>
                                <td>{{ $item->kode_surat }}</td>
                                <td>{{ $item->jenis_surat }}</td>
                                <td>
                                    <form method="POST" action="{{ route('jenis-surat.destroy', \Crypt::encrypt($item->id)) }}">
                                    @csrf
                                    <input type="hidden" name="_method" value="DELETE">
                                    <div class="form-group row mb-0">
                                        <div class="col-md-12">
                                            <a href="{{ route('jenis-surat.edit', \Crypt::encrypt($item->id)) }}">
                                                <button type="button" class="btn btn-primary">
                                                    {{ __('Edit') }}
                                                </button>
                                                </a>
                                            <button type="submit" class="btn btn-danger" onclick="return confirm('anda yakin mau delete?')">
                                                {{ __('Delete') }}
                                            </button>
                                        </div>
                                    </div>
                                    </form>
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                        <tfoot>
                            <tr>
                                <th>Kode Surat</th>
                                <th>Jenis Surat</th>
                                <th>Aksi</th>
                            </tr>
                        </tfoot>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('script')
    <script src="{{ URL::asset('js/jenis-surat.js') }}"></script>
@endsection